import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/date-table/vue";
import { defineComponent, $prefix, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import { isDate } from "@dft-vue-2-opentiny/vue-renderless/common/deps/date-util";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dft-vue-2-opentiny/vue-theme/date-table/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "DateTable",
  emits: ["changerange", "pick"],
  props: {
    value: {},
    defaultValue: {
      validator: function validator(value) {
        return value === null || isDate(value) || Array.isArray(value) && value.every(isDate);
      }
    },
    firstDayOfWeek: {
      default: 7,
      type: Number,
      validator: function validator2(value) {
        return value >= 1 && value <= 7;
      }
    },
    date: {},
    selectionMode: {
      default: "day"
    },
    disabledDate: {},
    cellClassName: {},
    maxDate: {},
    minDate: {},
    showWeekNumber: {
      type: Boolean,
      default: false
    },
    rangeState: {
      default: function _default() {
        return {
          endDate: null,
          selecting: false
        };
      }
    },
    formatWeeks: Function
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("table", {
    class: ["tiny-date-table", {
      "is-week-mode": _vm.selectionMode === "week"
    }],
    attrs: {
      "cellspacing": "0",
      "cellpadding": "0"
    },
    on: {
      "mousemove": function mousemove($event) {
        $event.stopPropagation();
        return _vm.handleMouseMove($event);
      },
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.handleClick($event);
      }
    }
  }, [_c("tbody", [_c("tr", [_vm.showWeekNumber ? _c("th", [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.week")) + " ")]) : _vm._e(), _vm._l(_vm.state.weeks, function(weekDay, key) {
    return _c("th", {
      key
    }, [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.weeks." + weekDay)) + " ")]);
  })], 2), _vm._l(_vm.state.rows, function(row, key) {
    return _c("tr", {
      key,
      class: ["tiny-date-table__row", {
        current: _vm.isWeekActive(row[1])
      }]
    }, _vm._l(row, function(cellValue, key2) {
      return _c("td", {
        key: key2,
        class: _vm.getCellClasses(cellValue)
      }, [_c("div", [_c("span", [_vm._v(" " + _vm._s(cellValue.text) + " ")])])]);
    }), 0);
  })], 2)]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var DateTable = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
DateTable.install = function(Vue) {
  Vue.component(DateTable.name, DateTable);
};
DateTable.version = version;
export {
  DateTable as default
};
